<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'TheSourceNewsletter',
  data() {
    return {
      submitted: false,
      formIds: {
        'de-de': 28465,
        'en-us': 1077,
        'ja-jp': 28467,
        'it-it': 28469,
        es: 28470,
        'fr-fr': 28453,
        'pt-br': 28471,
      },
    };
  },
  computed: {
    currentFormId() {
      const locale = this.$i18n.locale;
      return this.formIds[locale] || this.formIds['en-us'];
    },
  },
  mounted() {
    this.refreshForm();
  },
  methods: {
    onFormSubmit() {
      this.$emit('submit');
    },
    refreshForm() {
      window.MktoForms2.setOptions({
        formXDPath: '/rs/194-VVC-221/images/marketo-xdframe-relative.html',
      });
      window.MktoForms2.loadForm(
        '//page.gitlab.com',
        '194-VVC-221',
        this.currentFormId,
        (form) => {
          form.onSuccess(() => {
            this.submitted = true;

            // eslint-disable-next-line no-undef
            dataLayer.push({
              event: 'thesourcenewsletter',
              mktoFormId: form.getId(),
              eventCallback() {
                form.getFormElem().hide();
              },
              eventTimeout: 3000,
            });
            return false;
          });

          function getgacid() {
            try {
              // eslint-disable-next-line no-undef
              const tracker = ga.getAll()[0];
              return tracker.get('clientId');
            } catch (e) {
              return 'n/a';
            }
          }

          form.vals({
            gacid: getgacid(),
          });
        },
      );
    },
  },
});
</script>

<template>
  <div id="subscribe" class="ts-newsletter">
    <script src="//page.gitlab.com/js/forms2/js/forms2.min.js"></script>
    <SlpContainer>
      <SlpTypography tag="h2" variant="heading2-bold">{{
        $t('articles.newsletter')
      }}</SlpTypography>
      <SlpTypography class="slp-mb-32" tag="h5" variant="heading5">{{
        $t('articles.newsletterDescription')
      }}</SlpTypography>

      <div class="form-container">
        <form v-if="!submitted" :id="`mktoForm_${currentFormId}`" />
        <div v-else class="ts-newsletter__submitted">
          <SlpTypography tag="p" variant="heading5">{{
            $t('articles.newsletterSubmit')
          }}</SlpTypography>
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style scoped lang="scss">
.ts-newsletter {
  background-color: $color-surface-100;
  padding: $spacing-48 0;

  @media (width >= $breakpoint-md) {
    padding: $spacing-96 0;
  }

  &__submitted {
    display: flex;
    align-items: center;
    justify-content: center;
    background-color: $color-primary-300;
    padding: $spacing-24 $spacing-24;
    box-shadow: 0 1px 4px 0 rgba(0, 0, 0, 0.102);
    border-radius: 8px;
    overflow: hidden;
  }

  // Marketo form adjustments
  &:deep {
    .form_header {
      display: none !important;
    }

    .form_column .form_container {
      padding: $spacing-24 !important;
    }

    .mktoOffset,
    .mktoGutter {
      margin: 0 !important;
      padding: 0 !important;
      height: 0 !important;
    }

    #LblCountry {
      @media (width >= $breakpoint-md) {
        margin-top: 0 !important;
      }
    }

    .mktoForm_container {
      display: flex;
      flex-wrap: wrap;
      flex-direction: column;
      padding: 0;
    }

    .mktoFormRow {
      display: flex;
      flex-flow: row;
      max-width: 100%;
      width: 100%;
      box-sizing: border-box;
      overflow: hidden;

      &:has(input[type='hidden']) {
        display: none;
      }
    }

    .mktoFormCol {
      width: 100% !important;
    }

    .mktoButtonWrap button {
      margin: 0 !important;
    }

    .mktoHtmlText {
      margin: 0 0 $spacing-8 !important;

      a {
        padding: 0;
      }
    }

    .form_column.slp-px-md-32 {
      padding-left: 0 !important;
      padding-right: 0 !important;
      margin: 0 !important;
    }
  }
}
</style>

<style lang="scss">
// CUSTOM STYLES FOR THIS PAGE

#mktoForm_1077,
#mktoForm_28465,
#mktoForm_28467,
#mktoForm_28469,
#mktoForm_28470,
#mktoForm_28453,
#mktoForm_28471 {
  display: grid;
  column-gap: 16px;
  grid-template-columns: 1fr 1fr 1fr;
  width: initial !important;
  background: white;
  padding: 24px;
  border-radius: 8px;
  box-shadow: 0px 1px 4px 0px #0000001a;
  overflow: hidden;

  @media (max-width: 1024px) {
    grid-template-columns: 1fr;
  }

  .mktoFormRow:has(.mktoHtmlText) {
    grid-column: 1 / -1;
  }

  .mktoHtmlText {
    width: unset !important;
  }

  .mktoLabel {
    width: unset !important;
  }

  .mktoButtonWrap {
    margin-left: 0 !important;
  }

  .mktoTextField {
    width: initial !important;
  }

  .mktoEmailField {
    width: initial !important;
  }

  .mktoField {
    width: initial !important;
  }

  .mktoFieldWrap {
    display: flex;
    flex-direction: column;
    grid-gap: 8px;
    width: 100%;
  }

  input {
    padding: 13px 16px;
    border-style: solid;
    border-width: 1px;
    border-radius: 4px;

    @media (max-width: 480px) {
      padding: 22px 16px;
    }
  }

  select {
    padding: 13px 16px;
    border-radius: 2px;
    appearance: none;
    width: 300px;
    background: url('/nuxt-images/icons/dropdown-chevron.svg') no-repeat 97%
      center;
    background-size: 9px;
    border: 1px solid #777 !important;
    border-radius: 4px;
    color: black !important;
    width: 100%;
    max-width: 100%;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
    box-sizing: border-box;

    @media (max-width: 768px) {
      font-size: 16px;
      padding: 10px 16px;
    }
  }

  .mktoButton {
    padding: 12px 16px 12px 16px;
    border-radius: 4px;
    background: #171321;
    color: white;
    box-shadow: none;

    &:hover {
      background: white;
      color: #171321;
    }

    @media (max-width: 480px) {
      width: 100%;
    }
  }
}
</style>
